<h1 id="all-about-testing">ALL ABOUT TESTING</h1>
<p>Why do we test? 1. To make sure everything works 2. To increase flexibility and reduce fear - oftentimes we have to go back and refactor code - w/o tests you’d be walking on eggshells, frightened of breaking stuff - w/ tests you can refactor w/ confidence - if anything breaks, you’ll know 3. Make collaboration easier - you have expectations for the module youre working on - specs are effective form of communication - as long as you meet the specs you should be good to go 4. Produce documentation - if well writtene, specs can be documentation for code base - not sure what a module does? look at specs</p>
<p>Testing Framework vs Assertion Library - testing framework: runs tests and presents them to a user - assertion library: the code we use to write our tests - does heavy lifting of comparing and verifying our code - some frameworks have built in assertion libraries, some you will need to require</p>
<p>Mocha - testing framework: runs tests and presents them to user - supports variety of assertion libraries - has DSL that provides structure for writing tests - DSL: computer language specialized for particular purpose - i.e provides structure for written tests</p>
<p>What do we test? * "think less about the code and more about the use cases the code supports" - use case coverage:
    how many use cases our code supports</p>
<p>The Testing Pyramid 1. Unit Tests - smallest unit of testing - tests smallest pieces of app in isolation to ensure each piece works before you put those pieces toegether - should focus on testing one thing 2. Integration Tests - after unit tests are in place, test the interaction of those pieces - ensure units work coherently together 3. End-to-End (E2E) Tests - test the whole of your application - closest automated tests come to testing actual user experience</p>
<p>Test Pyramid Chess Example 1. Unit test - test each class in isolation - ensure each piece’s instance methods work before involving other pieces 2. Integration Test - ensure each piece instance interacts with Board class correctly 3. E2E Testing - testing a round of chess - test that Game, Piece, Board interact correctly</p>
<p>Reading Tests - most important thing is that test is readable and understandable - use descriptive strings to explain what they teest and how</p>
<h1 id="test-driven-development-tdd">Test-Driven Development (TDD)</h1>
<p>What is TDD - software development process - tests should be written before you write the code - code should only be written to pass existing tests - repeat following cycle: 1. determine what code should do 2. write tests for that behavior 3. write actual code</p>
<p>TDD Motivations 1. Writing tests before code ensurese that the code written will work 2. Only required code is written 3. Helps enforce code modularity 4. Enforces better understanding of what thee code should be doing</p>
<p>TDD Process - "Red, Green, Refactor" 1. Red: write tests and watch them fail 2. Green: write minimum amt of code to
    ensure tests pass 3. Refactor: refactor code you just wrote so its easy to maintain and read</p>
<h1 id="javascript-error-types">JavaScript Error Types</h1>
<p>JavaScript Errors - <code>Error</code> constructor func creates instances of <code>Error</code> objects - type of error thrown attempts to communicate why error occurred</p>
<p>Creating your own errors - can use constructor func to create new <code>Error</code> object instances with syntax - can call with or without <code>new</code> keyword</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1">  <span class="co">// new Error([message[, fileName[, lineNumber]]])</span></a>
<a class="sourceLine" id="cb1-2" title="2"></a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="kw">let</span> myError <span class="op">=</span> <span class="kw">new</span> <span class="at">Error</span>(<span class="st">&quot;I am an error&quot;</span>)</a></code></pre></div>
<p>Throwing your own errors - use <code>throw</code> keyword to throw runtime errors and stop program execution - can use <code>try...catch</code> block to throw errors w/o stopping execution</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1">  <span class="kw">function</span> <span class="at">safeDivide</span>(a<span class="op">,</span> b) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">    <span class="cf">if</span> (b <span class="op">===</span> <span class="dv">0</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-3" title="3">      <span class="cf">throw</span> <span class="kw">new</span> <span class="at">Error</span>(<span class="st">&quot;cannot divide by zero&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-4" title="4">    <span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-5" title="5">      <span class="cf">return</span> a / b<span class="op">;</span></a>
<a class="sourceLine" id="cb2-6" title="6">    <span class="op">}</span></a>
<a class="sourceLine" id="cb2-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb2-8" title="8"></a>
<a class="sourceLine" id="cb2-9" title="9">  <span class="cf">try</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-10" title="10">    <span class="co">// statements that will be attempted</span></a>
<a class="sourceLine" id="cb2-11" title="11">    <span class="va">console</span>.<span class="at">log</span>(<span class="at">safeDivide</span>(<span class="dv">30</span><span class="op">,</span> <span class="dv">0</span>))<span class="op">;</span> </a>
<a class="sourceLine" id="cb2-12" title="12">  <span class="op">}</span> <span class="cf">catch</span> (error) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-13" title="13">    <span class="co">// if an error is thrown it will be &quot;caught&quot;</span></a>
<a class="sourceLine" id="cb2-14" title="14">    <span class="co">// allows program to continue execution</span></a>
<a class="sourceLine" id="cb2-15" title="15">    <span class="co">// statements here will  be run and program will continue</span></a>
<a class="sourceLine" id="cb2-16" title="16">    <span class="va">console</span>.<span class="at">error</span>(<span class="va">error</span>.<span class="at">name</span> <span class="op">+</span> <span class="st">&quot;: &quot;</span> <span class="op">+</span> <span class="va">error</span>.<span class="at">message</span>)<span class="op">;</span> <span class="co">// Error: cannot divide by zero</span></a>
<a class="sourceLine" id="cb2-17" title="17">  <span class="op">}</span></a>
<a class="sourceLine" id="cb2-18" title="18"></a>
<a class="sourceLine" id="cb2-19" title="19">  <span class="co">// above code will be caught and program can continue</span></a>
<a class="sourceLine" id="cb2-20" title="20">  <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;hello&quot;</span>)<span class="op">;</span> <span class="co">// prints hello</span></a></code></pre></div>
<p>Syntax Errors - thrown when JS engine attempts to parse code that doesn’t conform to syntax of JS language - many cant be caught by <code>try...catch</code> blocks b/c they happen at compile time, not at run time - any error that happens at compile time cant be caught</p>
<p>Refernece Errors - represents error when non-existent variable is referenced</p>
<p>Type Error - when operation cannot be performed b/c operand is value of wrong type - when attempting to modify value that cannot be changed (<code>const</code>)</p>
<p>Catching Known Errors - can catch specific error types using <code>instanceof</code></p>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">function</span> <span class="at">callThatArg</span>(arg) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-2" title="2">  <span class="at">arg</span>()<span class="op">;</span> <span class="co">// this will cause a TypeError because callThatArg is being passed a number</span></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="op">}</span></a>
<a class="sourceLine" id="cb3-4" title="4"></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="cf">try</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb3-6" title="6">  <span class="at">callThatArg</span>(<span class="dv">42</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-7" title="7">  <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;call successful&quot;</span>)<span class="op">;</span> <span class="co">// this line never executes</span></a>
<a class="sourceLine" id="cb3-8" title="8"><span class="op">}</span> <span class="cf">catch</span> (error) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-9" title="9">  <span class="cf">if</span> (error <span class="kw">instanceof</span> TypeError) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-10" title="10">    <span class="va">console</span>.<span class="at">error</span>(<span class="vs">`Wrong Type: </span><span class="sc">${</span><span class="va">error</span>.<span class="at">message</span><span class="sc">}</span><span class="vs">`</span>)<span class="op">;</span> <span class="co">// prints: Wrong Type: arg is not a function</span></a>
<a class="sourceLine" id="cb3-11" title="11">  <span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb3-12" title="12">    <span class="va">console</span>.<span class="at">error</span>(<span class="va">error</span>.<span class="at">message</span>)<span class="op">;</span> <span class="co">// prints out any errors that aren&#39;t TypeErrors;</span></a>
<a class="sourceLine" id="cb3-13" title="13">  <span class="op">}</span></a>
<a class="sourceLine" id="cb3-14" title="14"><span class="op">}</span></a>
<a class="sourceLine" id="cb3-15" title="15"></a>
<a class="sourceLine" id="cb3-16" title="16"><span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;done&quot;</span>)<span class="op">;</span> <span class="co">// prints: done</span></a></code></pre></div>
<h1 id="writing-tests">Writing Tests</h1>
<p>Mocha - one of JS’s most popular test frameworks - what we’ve been using in nour projects</p>
<p>Chai - assertion library commonly used with Mocha - provides funcs/methods that help you compare output of test with expected val</p>
<p>Assert - node’s built in assertion library</p>
<p>Chai provides three assertion styles you can choose from 1. Assert style <code>js        let assert = require('chai').assert       let nums = [1,2,3,4]       assert.isArray(nums, 'is array of nums')</code> 2. Expect style <code>js        let expect = require('chai').expect       let nums = [1,2,3,4]       expect(nums).to.be.an('array').that.includes(2);</code> 3. Should style <code>js        let should = require('chai').should       let nums = [1,2,3,4]       nums.should.be.an('array').that.includes(2);</code></p>
<p>Mocha interface system - allows us to choose style of DSL - BDD, TDD, EXPORTS, etc. - we will use BDD * describe(), context(), it(), specify(), before(), beforeEach(), after(), afterEach()</p>
<p>Part Zero: Testing File Structure - mocha CLI automatically looks for directory named <code>test</code> - file structure should mirror files you want to test</p>
<pre><code>testing-demo
  └──
  problems
    └── reverse-string.js
  test
    └── reverse-string-spec.js</code></pre>
<p>Part One: Writing Tests with Mocha and Assert - mocha: test framework specializing in running tests and presenting them in useer friendly way - assert: assertion library module, responsible for actually verifying things (does heavy lifting) * <code>describe()</code>: way to group tests, can deeply nest * <code>context()</code>: alias for describe, providse additional grouping * <code>it()</code>: provides the test case * <code>before()</code>: run once before all tests in a <code>describe</code> * <code>beforeEach()</code>: run before each test in a <code>describe</code> * <code>after()</code>: run once after all tests in a <code>describe</code> * <code>afterEach()</code>: run after each test in a <code>describe</code></p>
<div class="sourceCode" id="cb5"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1">  <span class="co">// test/reverse-string-spec.js</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="kw">const</span> assert <span class="op">=</span> <span class="at">require</span>(<span class="st">&quot;assert&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-3" title="3">  <span class="kw">const</span> reverseString <span class="op">=</span> <span class="at">require</span>(<span class="st">&quot;../problems/reverse-string.js&quot;</span>)</a>
<a class="sourceLine" id="cb5-4" title="4"></a>
<a class="sourceLine" id="cb5-5" title="5">  <span class="co">// function used to describe what we&#39;re testing</span></a>
<a class="sourceLine" id="cb5-6" title="6">  <span class="co">// cb argument will hold actual tests</span></a>
<a class="sourceLine" id="cb5-7" title="7">  <span class="at">describe</span>(<span class="st">&quot;reverseString()&quot;</span><span class="op">,</span> <span class="kw">function</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb5-8" title="8"></a>
<a class="sourceLine" id="cb5-9" title="9">    <span class="co">// it is organization func used to wrap each test we write</span></a>
<a class="sourceLine" id="cb5-10" title="10">    <span class="at">it</span>(<span class="st">&quot;should reverse the input string&quot;</span><span class="op">,</span> <span class="kw">function</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb5-11" title="11">      <span class="kw">let</span> test <span class="op">=</span> <span class="at">reverseString</span>(<span class="st">&quot;hello&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-12" title="12">      <span class="kw">let</span> result <span class="op">=</span> <span class="st">&quot;olleh&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-13" title="13"></a>
<a class="sourceLine" id="cb5-14" title="14">      <span class="va">assert</span>.<span class="at">strictEqual</span>(test<span class="op">,</span> result)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-15" title="15">    <span class="op">}</span>)</a>
<a class="sourceLine" id="cb5-16" title="16">  <span class="op">}</span>)</a></code></pre></div>
<p>Part Two: Testing Errors - must pass uninvoked method call to error testing - ensure error wont be throw until <code>assert.throws</code> is ready to catch it</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1">  <span class="at">context</span>(<span class="st">&quot;given an argument that is not a string&quot;</span><span class="op">,</span> <span class="kw">function</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="at">it</span>(<span class="st">&quot;should throw a TypeError when given an argument that is not a string&quot;</span><span class="op">,</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-3" title="3">    <span class="va">assert</span>.<span class="at">throws</span>(() <span class="kw">=&gt;</span> <span class="at">reverseString</span>(<span class="dv">3</span>)<span class="op">,</span> TypeError)<span class="op">;</span></a>
<a class="sourceLine" id="cb6-4" title="4">  <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb6-5" title="5"><span class="op">}</span>)<span class="op">;</span></a></code></pre></div>
<p>Part Three: Tseting Classes with Chai - Assert: assertion library, node module - Chai: another assertion library, has more functionality than Assert - Expect: Testing style included in Chai</p>
<p>Part Four: Mocha Hooks and Chai Spys - hooks used to dry up testing (before, beforeEach, after, afterEach) - Chai Spies: library that adds additional functionality to chai * ability to determine if function has been called and how many times</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1">  <span class="co">// testing-demo/test/dog-spec.js</span></a>
<a class="sourceLine" id="cb7-2" title="2"></a>
<a class="sourceLine" id="cb7-3" title="3">  <span class="co">// set up chai</span></a>
<a class="sourceLine" id="cb7-4" title="4">  <span class="kw">const</span> chai <span class="op">=</span> <span class="at">require</span>(<span class="st">&quot;chai&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-5" title="5">  <span class="kw">const</span> expect <span class="op">=</span> <span class="va">chai</span>.<span class="at">expect</span><span class="op">;</span></a>
<a class="sourceLine" id="cb7-6" title="6"></a>
<a class="sourceLine" id="cb7-7" title="7">  <span class="co">// set up chai spys</span></a>
<a class="sourceLine" id="cb7-8" title="8">  <span class="kw">const</span> spies <span class="op">=</span> <span class="at">require</span>(<span class="st">&quot;chai-spies&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-9" title="9">  <span class="va">chai</span>.<span class="at">use</span>(spies)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-10" title="10"></a>
<a class="sourceLine" id="cb7-11" title="11">  <span class="co">// don&#39;t forget to import the class you are testing!</span></a>
<a class="sourceLine" id="cb7-12" title="12">  <span class="kw">const</span> Dog <span class="op">=</span> <span class="at">require</span>(<span class="st">&quot;../problems/dog.js&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-13" title="13"></a>
<a class="sourceLine" id="cb7-14" title="14">  <span class="co">// our outer describe for the whole Dog class</span></a>
<a class="sourceLine" id="cb7-15" title="15">  <span class="at">describe</span>(<span class="st">&quot;Dog&quot;</span><span class="op">,</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-16" title="16"></a>
<a class="sourceLine" id="cb7-17" title="17">    <span class="kw">let</span> layla<span class="op">;</span></a>
<a class="sourceLine" id="cb7-18" title="18"></a>
<a class="sourceLine" id="cb7-19" title="19">    <span class="co">// creates new instance before each test</span></a>
<a class="sourceLine" id="cb7-20" title="20">    <span class="at">beforeEach</span>(<span class="st">&#39;set up a dog instance&#39;</span><span class="op">,</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-21" title="21">      layla <span class="op">=</span> <span class="kw">new</span> <span class="at">Dog</span>(<span class="st">&#39;Layla&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-22" title="22">    <span class="op">}</span>)</a>
<a class="sourceLine" id="cb7-23" title="23"></a>
<a class="sourceLine" id="cb7-24" title="24">    <span class="at">describe</span>(<span class="st">&quot;Dog constructor function&quot;</span><span class="op">,</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-25" title="25">      <span class="at">it</span>(<span class="st">&#39;should have a &quot;name&quot; property&#39;</span><span class="op">,</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-26" title="26">        <span class="co">// all tests will begin with expect</span></a>
<a class="sourceLine" id="cb7-27" title="27">        <span class="at">expect</span>(layla).<span class="va">to</span>.<span class="va">have</span>.<span class="at">property</span>(<span class="st">&quot;name&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-28" title="28">      <span class="op">}</span>)</a>
<a class="sourceLine" id="cb7-29" title="29">    <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-30" title="30"></a>
<a class="sourceLine" id="cb7-31" title="31">    <span class="at">describe</span>(<span class="st">&#39;prototype.chainChaseTail()`, () =&gt; {</span></a>
<a class="sourceLine" id="cb7-32" title="32">      <span class="at">context</span>(<span class="st">&quot;with a valid number parameter&quot;</span><span class="op">,</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-33" title="33">        <span class="at">it</span>(<span class="st">&quot;should call the chaseTail method n times&quot;</span><span class="op">,</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-34" title="34">          </a>
<a class="sourceLine" id="cb7-35" title="35">          <span class="co">// first arg is instance we&#39;re spying on</span></a>
<a class="sourceLine" id="cb7-36" title="36">          <span class="co">// second is method we&#39;re keeping track of </span></a>
<a class="sourceLine" id="cb7-37" title="37">          <span class="kw">const</span> chaseTailSpy <span class="op">=</span> <span class="va">chai</span>.<span class="va">spy</span>.<span class="at">on</span>(layla<span class="op">,</span> <span class="st">&quot;chaseTail&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-38" title="38"></a>
<a class="sourceLine" id="cb7-39" title="39">          <span class="co">// invoke the method we are spying on</span></a>
<a class="sourceLine" id="cb7-40" title="40">          <span class="va">layla</span>.<span class="at">chainChaseTail</span>(<span class="dv">3</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-41" title="41"></a>
<a class="sourceLine" id="cb7-42" title="42">          <span class="co">// actual test</span></a>
<a class="sourceLine" id="cb7-43" title="43">          <span class="at">expect</span>(chaseTailSpy).<span class="va">to</span>.<span class="va">have</span>.<span class="va">been</span>.<span class="va">called</span>.<span class="at">exactly</span>(<span class="dv">3</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-44" title="44">        <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-45" title="45">      <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-46" title="46">    <span class="op">}</span>)</a>
<a class="sourceLine" id="cb7-47" title="47">  })<span class="op">;</span></a></code></pre></div>
